<?php


/*
/// <param name="nombre">Nombre(s) de la persona</param>
/// <param name="apellidoPaterno">Apellido paterno de la persona</param>
/// <param name="apellidoMaterno">Apellido materno de la persona</param>
/// <param name="fecha">Fecha en formato dd/MM/yy (12/10/68)</param>
/// <returns>Regresa el RFC como cadena de caracteres</returns>
*/
function QuitarArticulos($palabra)
{
	$palabra=str_replace("DEL ","",$palabra);
	$palabra=str_replace("LAS ","",$palabra);
	$palabra=str_replace("DE ","",$palabra);
	$palabra=str_replace("LA ","",$palabra);
	$palabra=str_replace("Y ","",$palabra);
	$palabra=str_replace("A ","",$palabra);
	$palabra=str_replace("LOS ","",$palabra);
	$palabra=str_replace("DA ","",$palabra);
	$palabra=str_replace(" Y ","",$palabra);
	$palabra=str_replace("'","",$palabra);
	$palabra=str_replace("´","",$palabra);
	
	return $palabra;
}
function EsVocal($letra)
{
	if ($letra == 'A' || $letra == 'E' || $letra == 'I' || $letra == 'O' || $letra == 'U' ||
	$letra == 'a' || $letra == 'e' || $letra == 'i' || $letra == 'o' || $letra == 'u')
		return 1;
	else
		return 0;
}
function CalcularRFC($nombre,$apellidoPaterno,$apellidoMaterno,$fecha)
{
	/*Cambiamos todo a mayúsculas.
	Quitamos los espacios al principio y final del nombre y apellidos*/
	$nombre =strtoupper(trim($nombre));
	$SinUnApellido ="No";
	//Código agregado por FCR
	
	if ($apellidoMaterno == "")
	{
		$SinUnApellido ="Si";
	} 

	if ($apellidoPaterno == "") 
	{
		$apellidoPaterno = $apellidoMaterno;
		$apellidoMaterno ="";
		$SinUnApellido ="Si";
	}


	// Fin de Código generado

	$apellidoPaterno =strtoupper(trim($apellidoPaterno));
	$apellidoMaterno =strtoupper(trim($apellidoMaterno));

	//Quitamos los artículos de los apellidos
	$apellidoPaterno = QuitarArticulos($apellidoPaterno);
	$apellidoMaterno = QuitarArticulos($apellidoMaterno);


	//RFC que se regresará
	$rfc="";




	//Regla 1. Agregamos el primer caracter del apellido paterno
	$rfc = substr($apellidoPaterno,0, 1);

	//Regla 2. Buscamos y agregamos al rfc la primera vocal del primer apellido
	$len_apellidoPaterno=strlen($apellidoPaterno);

	$EncontroVocal = "No";
	for($x=1;$x<$len_apellidoPaterno;$x++)
	{
		$c=substr($apellidoPaterno,$x,1);
		if (EsVocal($c))
		{
			$rfc .= $c;
			$EncontroVocal = "Si";
			break;
		}
	}

	
	echo("<br>");
	echo("<br>");

	//Otro código añadido
	if ($EncontroVocal == "No")
	{
		//echo("<br> No encontro vocales");
		$rfc .= substr($apellidoPaterno,1,1);
	}


	if ($SinUnApellido =="Si")
	{

		//Buscamos y agregamos al rfc la primera vocal del primer apellido
		$len_nombre=strlen($nombre);

		$EncontroConsonante = "No";
		$letra="";
		for($x=1;$x<$len_nombre;$x++)
		{
			$c=substr($nombre,$x,1);
			if (!EsVocal($c))
			{
				$letra= $c;
				$EncontroConsonante = "Si";
				break;
			}
		}

		//Agregamos el primer caracter del primer nombre
		$rfc .= substr($nombre,0, 1);

		//Agregamos el primer caracter del apellido materno
		$rfc .= $letra;

		

	}
	else
	{
		//Agregamos el primer caracter del apellido materno
		$rfc .= substr($apellidoMaterno,0, 1);

		//Agregamos el primer caracter del primer nombre
		$rfc .= substr($nombre,0, 1);

	}

	$ValidaJoseMaria="No";
	ValidaJoseMaria($nombre, $rfc);

	

	/*$mystring = 'abc';
	$ValidaJoseMaria="No";

	$findme   = 'JOSE MARIA';
	$pos = strpos($nombre, $findme);
	if ($pos === true) 	
	{ 
		$rfc = substr($rfc,0, 3) .  substr($nombre,0, 1);
		$ValidaJoseMaria="Si";		
	}*/
	
	



	//Código agregado por mi MVE

	$search_array = array(	'BUEI'=>0,
							'CACA'=>1,
							'CAGA'=>2,
							'CAKA'=>3,
							'COGE'=>4,
							'COJE'=>5,
							'COJO'=>6,
							'FETO'=>7,
							'JOTO'=>8,
							'KACO'=>9,
							'KAGO'=>10,
							'KOJO'=>11,
							'KULO'=>12,
							'MAMO'=>13,
							'MEAS'=>14,
							'MION'=>15,
							'MULA'=>16,
							'PEDO'=>17,
							'PUTA'=>18,
							'QULO'=>19,
							'RUIN'=>20,
							'BUEY'=>21,
							'CACO'=>22,
							'CAGO'=>23,
							'CAKO'=>24,
							'COJA'=>25,
							'COJI'=>26,
							'CULO'=>27,
							'GUEY'=>28,
							'KACA'=>29,
							'KAGA'=>30,
							'KOGE'=>31,
							'KAKA'=>32,
							'MAME'=>33,
							'MEAR'=>34,
							'MEON'=>35,
							'MOCO'=>36,
							'PEDA'=>37,
							'PENE'=>38,
							'PUTO'=>39,
							'RATA'=>40);

	if (array_key_exists($rfc, $search_array)) {
	    //echo "The " . $Nombrecito . " element is in the array";
	    $rfc = substr($rfc, 0, 3) . "X";
	    //echo $Nombrecito;
	}

	//Aquí termina validaciones de nombres groseros




	//agregamos la fecha yymmdd (por ejemplo: 680825, 25 de agosto de 1968 )
	$rfc .= substr($fecha,6, 2).substr($fecha,3, 2).substr($fecha,0, 2);

	//Le agregamos la homoclave al rfc

	CalcularHomoclave($apellidoPaterno." ".$apellidoMaterno." ".$nombre, $fecha,$rfc);
	return $rfc;
}


function ValidaJoseMaria($nombre, &$rfc)
{

	$ValidaJoseMaria="No";
	$PalabraBuscar   = 'JOSE';
	
	if (substr($nombre,0, 10) == "JOSE MARIA") 
	{
		$rfc = substr($rfc,0, 3) . substr($nombre,0, 1);
	}
	elseif (substr($nombre,0, 4) == "JOSE") 
	{
		if (strlen($nombre) >=6)
		{
			$rfc = substr($rfc,0, 3) . substr($nombre,5, 1);	
		}
	}

	/*$pos = strpos($nombre, $PalabraBuscar);
	if ($pos === true) 	
	{ 
		$rfc = substr($rfc,0, 3) .  substr($nombre,0, 1);
		$ValidaJoseMaria="Si";	
		echo $ValidaJoseMaria;	
	}*/


	return $rfc;
}


function CalcularHomoclave($nombreCompleto,$fecha, &$rfc)
{
	//Guardara el nombre en su correspondiente numérico
	//agregamos un cero al inicio de la representación númerica del nombre
	$nombreEnNumero="0";
	//La suma de la secuencia de números de nombreEnNumero
	$valorSuma = 0;

	#region Tablas para calcular la homoclave
	//Estas tablas realmente no se porque son como son
	//solo las copie de lo que encontré en internet

	$tablaRFC1['&']='10';
	$tablaRFC1['Ñ']='10';
	$tablaRFC1['A']='11';
	$tablaRFC1['B']='12';
	$tablaRFC1['C']='13';
	$tablaRFC1['D']='14';
	$tablaRFC1['E']='15';
	$tablaRFC1['F']='16';
	$tablaRFC1['G']='17';
	$tablaRFC1['H']='18';
	$tablaRFC1['I']='19';
	$tablaRFC1['J']='21';
	$tablaRFC1['K']='22';
	$tablaRFC1['L']='23';
	$tablaRFC1['M']='24';
	$tablaRFC1['N']='25';
	$tablaRFC1['O']='26';
	$tablaRFC1['P']='27';
	$tablaRFC1['Q']='28';
	$tablaRFC1['R']='29';
	$tablaRFC1['S']='32';
	$tablaRFC1['T']='33';
	$tablaRFC1['U']='34';
	$tablaRFC1['V']='35';
	$tablaRFC1['W']='36';
	$tablaRFC1['X']='37';
	$tablaRFC1['Y']='38';
	$tablaRFC1['Z']='39';
	$tablaRFC1['0']='00';
	$tablaRFC1['1']='01';
	$tablaRFC1['2']='02';
	$tablaRFC1['3']='03';
	$tablaRFC1['4']='04';
	$tablaRFC1['5']='05';
	$tablaRFC1['6']='06';
	$tablaRFC1['7']='07';
	$tablaRFC1['8']='08';
	$tablaRFC1['9']='09';

	$tablaRFC2[0]="1";
	$tablaRFC2[1]="2";
	$tablaRFC2[2]="3";
	$tablaRFC2[3]="4";
	$tablaRFC2[4]="5";
	$tablaRFC2[5]="6";
	$tablaRFC2[6]="7";
	$tablaRFC2[7]="8";
	$tablaRFC2[8]="9";
	$tablaRFC2[9]="A";
	$tablaRFC2[10]="B";
	$tablaRFC2[11]="C";
	$tablaRFC2[12]="D";
	$tablaRFC2[13]="E";
	$tablaRFC2[14]="F";
	$tablaRFC2[15]="G";
	$tablaRFC2[16]="H";
	$tablaRFC2[17]="I";
	$tablaRFC2[18]="J";
	$tablaRFC2[19]="K";
	$tablaRFC2[20]="L";
	$tablaRFC2[21]="M";
	$tablaRFC2[22]="N";
	$tablaRFC2[23]="P";
	$tablaRFC2[24]="Q";
	$tablaRFC2[25]="R";
	$tablaRFC2[26]="S";
	$tablaRFC2[27]="T";
	$tablaRFC2[28]="U";
	$tablaRFC2[29]="V";
	$tablaRFC2[30]="W";
	$tablaRFC2[31]="X";
	$tablaRFC2[32]="Y";
	$tablaRFC2[33]="Z";

	$tablaRFC3['A']=10;
	$tablaRFC3['B']=11;
	$tablaRFC3['C']=12;
	$tablaRFC3['D']=13;
	$tablaRFC3['E']=14;
	$tablaRFC3['F']=15;
	$tablaRFC3['G']=16;
	$tablaRFC3['H']=17;
	$tablaRFC3['I']=18;
	$tablaRFC3['J']=19;
	$tablaRFC3['K']=20;
	$tablaRFC3['L']=21;
	$tablaRFC3['M']=22;
	$tablaRFC3['N']=23;
	$tablaRFC3['O']=25;
	$tablaRFC3['P']=26;
	$tablaRFC3['Q']=27;
	$tablaRFC3['R']=28;
	$tablaRFC3['S']=29;
	$tablaRFC3['T']=30;
	$tablaRFC3['U']=31;
	$tablaRFC3['V']=32;
	$tablaRFC3['W']=33;
	$tablaRFC3['X']=34;
	$tablaRFC3['Y']=35;
	$tablaRFC3['Z']=36;
	$tablaRFC3['0']=0;
	$tablaRFC3['1']=1;
	$tablaRFC3['2']=2;
	$tablaRFC3['3']=3;
	$tablaRFC3['4']=4;
	$tablaRFC3['5']=5;
	$tablaRFC3['6']=6;
	$tablaRFC3['7']=7;
	$tablaRFC3['8']=8;
	$tablaRFC3['9']=9;
	$tablaRFC3['']=24;
	$tablaRFC3[' ']=37;

	//Recorremos el nombre y vamos convirtiendo las letras en
	//su valor numérico
	$len_nombreCompleto=strlen($nombreCompleto);
	for($x=0;$x<$len_nombreCompleto;$x++)
	{
		$c=substr($nombreCompleto,$x,1);
		if (isset($tablaRFC1[$c]))
			$nombreEnNumero.=$tablaRFC1[$c];
		else
			$nombreEnNumero.="00";
	}
	//Calculamos la suma de la secuencia de números
	//calculados anteriormente
	//la formula es:
	//( (el caracter actual multiplicado por diez)
	//mas el valor del caracter siguiente )
	//(y lo anterior multiplicado por el valor del caracter siguiente)

	$n=strlen($nombreEnNumero)-1;
	for ($i = 0; $i < $n; $i++)
	{
	$prod1 = substr($nombreEnNumero, $i, 2);
	$prod2 = substr($nombreEnNumero, $i + 1, 1);
	$valorSuma += $prod1 * $prod2;
	}
	//Lo siguiente no se porque se calcula así, es parte del algoritmo.
	//Los magic numbers que aparecen por ahí deben tener algún origen matemático
	//relacionado con el algoritmo al igual que el proceso mismo de calcular el
	//digito verificador.
	//Por esto no puedo añadir comentarios a lo que sigue, lo hice por acto de fe.
	$div = 0;
	$mod = 0;
	$div = $valorSuma % 1000;
	$mod = floor($div / 34);//cociente
	$div = $div - $mod * 34;//residuo

	$hc = $tablaRFC2[$mod];
	$hc.= $tablaRFC2[$div];

	$rfc .= $hc;

	//Aqui empieza el calculo del digito verificador basado en lo que tenemos del RFC
	//En esta parte tampoco conozco el origen matemático del algoritmo como para dar
	//una explicación del proceso, así que ¡tengamos fe hermanos!.
	$sumaParcial = 0;
	$n=strlen($rfc);
	for ($i = 0; $i < $n; $i++)
	{
	$c=substr($rfc,$i,1);
	if (isset($tablaRFC3[$c]))
	{
	$sumaParcial += ($tablaRFC3[$c] * (14 - ($i + 1)));
	}
	}

	$moduloVerificador = $sumaParcial % 11;
	if ($moduloVerificador == 0)
	$rfc .= "0";
	else
	{
	$sumaParcial = 11 - $moduloVerificador;
	if ($sumaParcial == 10)
	$rfc .= "A";
	else
	$rfc .= $sumaParcial;
	}
	}




function GenerarCurp($rfc, $Nombre, $ApellidoPaterno, $ApellidoMaterno, $Estado, $Sexo, &$curp)
{
	return $curp = substr($rfc,0,10) . $Sexo . CodigoEstado($Estado) . ObtenerConsonantesCurp($ApellidoPaterno) .  ObtenerConsonantesCurp($ApellidoMaterno). ObtenerConsonantesCurp($Nombre); 

	
}


function ObtenerConsonantesCurp($dato)
{	
	$len_dato=strlen($dato);
	
	for($x=1;$x<$len_dato;$x++)
	{	

		$c=substr($dato,$x,1);
		if (!EsVocal($c))
		{
			$resultado = $c;
			$EncontroVocal = "Si";
			break;
		}
	}
	return $resultado;
}

function CodigoEstado($Estado)
{
	if ($Estado=='Aguascalientes') {$clave='AS';}
	elseif ($Estado=='Baja California') {$clave='BC';}
	elseif ($Estado=='Baja California Sur') {$clave='BS';}
	elseif ($Estado=='Campeche') {$clave='CC';}
	elseif ($Estado=='Chiapas') {$clave='CS';}
	elseif ($Estado=='Chihuahua') {$clave='CH';}
	elseif ($Estado=='Ciudad de México') {$clave='DF';}
	elseif ($Estado=='Coahuila') {$clave='CL';}
	elseif ($Estado=='Colima') {$clave='CM';}
	elseif ($Estado=='Durango') {$clave='DG';}
	elseif ($Estado=='Guanajuato') {$clave='GT';}
	elseif ($Estado=='Guerrero') {$clave='GR';}
	elseif ($Estado=='Hidalgo') {$clave='HG';}
	elseif ($Estado=='Jalisco') {$clave='JC';}
	elseif ($Estado=='México') {$clave='MC';}
	elseif ($Estado=='Michoacán') {$clave='MN';}
	elseif ($Estado=='Morelos') {$clave='MS';}
	elseif ($Estado=='Nayarit') {$clave='NT';}
	elseif ($Estado=='Nuevo León') {$clave='NL';}
	elseif ($Estado=='Oaxaca') {$clave='OC';}
	elseif ($Estado=='Puebla') {$clave='PL';}
	elseif ($Estado=='Querétaro') {$clave='QO';}
	elseif ($Estado=='Quintana Roo') {$clave='QR';}
	elseif ($Estado=='San Luis Potosí') {$clave='SP';}
	elseif ($Estado=='Sinaloa') {$clave='SL';}
	elseif ($Estado=='Sonora') {$clave='SR';}
	elseif ($Estado=='Tabasco') {$clave='TC';}
	elseif ($Estado=='Tamaulipas') {$clave='TS';}
	elseif ($Estado=='Tlaxcala') {$clave='TL';}
	elseif ($Estado=='Veracruz') {$clave='VZ';}
	elseif ($Estado=='Yucatán') {$clave='YN';}
	elseif ($Estado=='Zacatecas') {$clave='ZS';}
	return $clave;
}

?>



<?php
	
	//echo CalcularRFC("FIDELIO","CASTILLO","ROMERO","20-02-77");
	echo "  ";
	//echo CalcularRFC("ANGEL","REYES","PEREZ","09-01-80");

	echo " -- ";
	//echo CalcularRFC("ANGEL","REYES","","09-01-80");
	//echo CalcularRFC("JAQUELINE","AG","IBARRA","02-04-62");
	//echo CalcularRFC("JOSE PEDRO JUAN","LOMAS","JUAREZ","02-04-62");
	//echo CalcularRFC("JOSE MARIA","LOPEZ","BAUTISTA","02-04-62");
	//echo $rfc = CalcularRFC("JAQUELINE","AG","IBARRA","02-04-62");

	$curp ="";
	
	$nombre = "JULIO ALBERTO";
	$apellidoPaterno= "SILVAN";
	$apellidoMaterno="ROMERO";
	$dia = "27";
	$mes ="04";
	$anio = "98";
	$fecha = $dia . "-" . $mes . "-" . $anio;
	$estado = "Tabasco";
	$sexo = "H";
	//$rfc = 
	echo "<hr>";
	$rfc=CalcularRFC($nombre,$apellidoPaterno,$apellidoMaterno,$fecha);	
	
	echo $rfc;
	echo "<hr>";
	$nombre =strtoupper(trim($nombre));
	echo GenerarCurp($rfc, $nombre, $apellidoPaterno, $apellidoMaterno, $estado, $sexo, $curp);	
	


?>


<?php

/* 	AS	Aguascalientes
	BC	Baja California
	BS	Baja California Sur
	CC	Campeche
	CS	Chiapas
	CH	Chihuahua
	DF	Ciudad de México
	CL	Coahuila
	CM	Colima
	DG	Durango
	GT	Guanajuato
	GR	Guerrero
	HG	Hidalgo
	JC	Jalisco
	MC	México
	MN	Michoacán
	MS	Morelos
	NT	Nayarit
	NL	Nuevo León
	OC	Oaxaca
	PL	Puebla
	QO	Querétaro
	QR	Quintana Roo
	SP	San Luis Potosí
	SL	Sinaloa
	SR	Sonora
	TC	Tabasco
	TS	Tamaulipas
	TL	Tlaxcala
	VZ	Veracruz
	YN	Yucatán
	ZS	Zacatecas
*/

?>
