$(document).ready(inicializar);
function inicializar() {

    //Sistema de formulario paso por paso
    $(".matricula").hide();
    $(".discapacidad").hide();
    $(".direccion").hide();
    $(".laborales").hide();
    $(".periodo").hide();
    $(".semestre").hide();
    $(".option_laboral").hide();
    $(".alerta").hide();
    $(".materias").hide();

    function allHide(clase){
        $(".bancaria").hide();
        $(".matricula").hide();
        $(".discapacidad").hide();
        $(".direccion").hide();
        $(".laborales").hide();
        $(".periodo").hide();
        $(".semestre").hide();
        $(".option_laboral").hide();
        $(".alerta").hide();
        $(".materias").hide();
        $("."+clase).show();
    }

    //Botones de anterior y siguiente para cada formulario
    $("#mat_ant").click(function(){
        allHide('bancaria')
    });
    $("#mat_sig").click(function(){
        if($("#frmatricula").val()!=""){
            if($("#al_nombre").text()!=""){
                allHide('discapacidad')    
            }else{
                $(".alert_matricula").html("<div class='alert alert-danger' role='alert'>La matricula ingresada no es correcta</div>");
            }
        }else{
            $(".alert_matricula").html("<div class='alert alert-danger' role='alert'>Introduzca la matricula</div>");
        }
    });


    $("#dis_ant").click(function(){
        allHide('matricula')
    });
    $("#dis_sig").click(function(){
        allHide('direccion')
    });


    $("#dir_ant").click(function(){
        allHide('discapacidad');
    });
    $("#dir_sig").click(function(){
        if($("#frcalle")!="" && $("#frcolonia")!="" && $("#frcp")!="" && $("#frlocalidad")!="" && $("#fredad").val()!="" && $("#frcorreo").val()!="" && $("#frcelular").val()!=""){
            if(!/^[A-Z ]+$/.test($("#frlocalidad").val())){
                $("#alert_direction").html("<div class='alert alert-danger' role='alert'>El campo localidad solo permite letras mayusculas</div>");
            }else if(!/^[0-9]/.test($("#frcp").val())){
                $("#alert_direction").html("<div class='alert alert-danger' role='alert'>El campo codigo postal solo permite numeros</div>");
            }else{
                allHide('option_laboral');
            }
        }else{
            $("#alert_direction").html("<div class='alert alert-danger' role='alert'>Debe rellenar todos los campos</div>");
        }
    });


    $("#lab_ant").click(function(){
        allHide('option_laboral')
    });
    $("#lab_sig").click(function(){
        allHide('periodo')
    });


    $("#per_ant").click(function(){
        allHide('option_laboral')
    });
    $("#per_sig").click(function(){
        if($("#frregular").val()=="SI"){
            var carrera=$("#al_clave").text();
            if(carrera=="170"){
                $(".especialidad").html(`
                <div class="form-group col-md-4">
                    <label for="frespecialidad">Seleccione especialidad</label>
                    <select  class="form-control" id="frespecialidad"  required>
                        <option value="1">SIN ESPECIALIDAD</option>
                        <option value="2">PREESCOLAR</option>
                        <option value="3">PRIMARIA</option>
                    </select>
                </div>`);
            }else if(carrera=="174"){
                $(".especialidad").html(`
                <div class="form-group col-md-4">
                    <label for="frespecialidad">Seleccione especialidad</label>
                    <select  class="form-control" id="frespecialidad"  required>
                        <option value="4">SIN ESPECIALIDAD</option>
                        <option value="5">EDUCACION INICIAL</option>
                        <option value="6">EDUCACION PARA JOVENES Y ADULTOS</option>
                    </select>
                </div>`);
            }
            allHide('semestre')
        }else{
            allHide('alerta')
        }
    });

    $("#ale_ant").click(function(){
        allHide('periodo');
    });


    $("#btnBancaria").click(function(){
        var pago=$("#banamex").val();
        if(pago!=""){
            allHide('matricula');
            //$(".bancaria").hide();
            //$(".matricula").show();
        }
    })


    $("#sem_ant").click(function(){
        allHide('periodo');
    });
    $("#sem_sig").click(function(){
        var semestre=$("#frsemestre").val();
        var carrera=$("#al_clave").text();
        var especialidad=$("#frespecialidad").val();
        if(especialidad=="1" || especialidad=="2" || especialidad=="3"){
            fetch('controller/reinscripcion.php',{
                method:'POST',
                body:JSON.stringify({'indicador':'especialidad', 'semestre':semestre, 'carreraid':1, 'tipo':especialidad})
            })
            .then(response=>response.text())
            .then(result=>{
                $(".list_materias").html(result);
                allHide('materias')
            })
        }else if(especialidad=="4" || especialidad=="5" || especialidad=="6"){
            fetch('controller/reinscripcion.php',{
                method:'POST',
                body:JSON.stringify({'indicador':'especialidad', 'semestre':semestre, 'carreraid':6, 'tipo':especialidad})
            })
            .then(response=>response.text())
            .then(result=>{
                $(".list_materias").html(result);
                allHide('materias')
            })
        }else{
            fetch('controller/reinscripcion.php',{
                method:'POST',
                body:JSON.stringify({'indicador':'materias','semestre':semestre, 'carrera':carrera})
            })
            .then(response=>response.text())
            .then(result=>{
                $(".list_materias").html(result);
                allHide('materias')
            })
        }   
    });


    $("#mate_ant").click(function(){
        allHide('semestre');
    });

    //Fin de sistema de formulario paso por paso


    //Validacion del pago bancario
    $('#mcajero').on('click', function(e) {
        e.preventDefault();
        $("#myModal").modal("show");
    
      });
      $('#mventanilla').on('click', function(e) {
        e.preventDefault();
        $("#ModalVentanilla").modal("show");
      });

      $("#btn_buscar").click(function(){
        if($("#frmatricula").val()!=""){
            fetch('controller/reinscripcion.php',{
                method:'POST',
                body:JSON.stringify({'indicador':'smatricula','matricula':$("#frmatricula").val()})
            })
            .then(response=>response.text())
            .then(result=>{
                $(".infoAlumno").html(result);
            })
        }
    })
    //Validaciones datos laborales
    $("#btn_si").click(function(){
        allHide('laborales');
    });
    $("#btn_no").click(function(){
        allHide('periodo');
    });

    //Obtenemos fecha 
    var getFecha = new Date;
    var year = getFecha.getFullYear();
    var month = getFecha.getMonth() + 1;
    var day = getFecha.getDate();
    var mes = "";

    if (month == 1){
      var mes = 'ENERO';
    }else if(month == 2){
      var mes = 'FEBRERO';
    }else if(month == 3){
      var mes = 'MARZO';
    }else if(month == 4){
      var mes = 'ABRIL';
    }else if (month == 5){
      var mes = 'MAYO';
    }else if (month == 6){
      var mes = 'JUNIO';
    }else if(month == 7){
      var mes = 'JULIO';
    }else if(month == 8){
      var mes = 'AGOSTO';
    }else if(month == 9){
      var mes = 'SEPTIEMBRE';
    }else if(month == 10){
      var mes = 'OCTUBRE';
    }else if(month == 11){
      var mes = 'NOVIEMBRE';
    }else if(month == 12){
      var mes = 'DICIEMBRE';
    }

    //Registrar en la tabla reinscritos
    

    $("#btn_registrar").click(function(){

        var nombre=$("#al_nombre").text();
    var aPaterno=$("#al_aPaterno").text();
    var aMaterno=$("#al_aMaterno").text();
    var sede=$("#al_sede").text();
    var estado=$("#al_estado").text();
    var curp=$("#al_curp").text();
    var rfc=$("#al_rfc").text();
    var sexo=$("#al_sexo").text();
    var fecha_nac=$("#al_fecha_nac").text();
    var sem_act=$("#al_sem_act").text();
    var sem_sig=$("#frsemestre").val();
    var carrera=$("#al_carrera").text();
    carrera = carrera.replace("'", "");
    var clave=$("#al_clave").text();
    var pago=$("#re_bancaria").val();
    var discapacidad=$("#frdiscapacidad").val();
    var matricula=$("#frmatricula").val();

    var data={
        'indicador':'add',
        'nombre':nombre,
        'aPaterno':aPaterno,
        'aMaterno':aMaterno,
        'sede':sede,
        'estado':estado,
        'curp':curp,
        'rfc':rfc,
        'sexo':sexo,
        'fecha_nac':fecha_nac,
        'sem_act':sem_act,
        'sem_sig':sem_sig,
        'carrera':carrera,
        'clave':clave,
        'pago':pago,
        'discapacidad':discapacidad,
        'fecha': day+' DE '+mes+' DEL '+year,
        'matricula':matricula

    }

        fetch('controller/reinscripcion.php',{
            method:'POST',
            body:JSON.stringify(data)
        })
        .then(response=>response.json())
        .then(result=>{

        })
    });
}